#ifndef INC_BE_APPLET__CUSTOM_FILE_MENU_ITEM_H
#define INC_BE_APPLET__CUSTOM_FILE_MENU_ITEM_H

#include <gtk/gtk.h>

#include "file-menu-item.h"

#define BE_CUSTOM_FILE_MENU_ITEM_TYPE            (be_custom_file_menu_item_get_type())
#define BE_CUSTOM_FILE_MENU_ITEM(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), BE_CUSTOM_FILE_MENU_ITEM_TYPE, BeCustomFileMenuItem))
#define BE_CUSTOM_FILE_MENU_ITEM_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), BE_CUSTOM_FILE_MENU_ITEM_TYPE, BeCustomFileMenuItemClass))
#define BE_IS_CUSTOM_FILE_MENU_ITEM(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BE_CUSTOM_FILE_MENU_ITEM_TYPE))
#define BE_IS_CUSTOM_FILE_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BE_CUSTOM_FILE_MENU_ITEM_TYPE))
#define BE_CUSTOM_FILE_MENU_ITEM_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), BE_CUSTOM_FILE_MENU_ITEM_TYPE, BeCustomFileMenuItemClass))

typedef struct _BeCustomFileMenuItem BeCustomFileMenuItem;
typedef struct _BeCustomFileMenuItemClass BeCustomFileMenuItemClass;

struct _BeCustomFileMenuItem {
	BeFileMenuItem parent;

	/* public */
	gchar *custom_text;
	gchar *custom_image_stock;
};

struct _BeCustomFileMenuItemClass {
	BeFileMenuItemClass parent;
};

GType be_custom_file_menu_item_get_type(void);

GtkWidget *be_custom_file_menu_item_new(const gchar *uri, BeIconLoader *icon_loader, GtkIconSize icon_size);

void be_custom_file_menu_item_set_text(BeCustomFileMenuItem *custom_file_menu_item, const gchar *text);

void be_custom_file_menu_item_set_image_from_stock(BeCustomFileMenuItem *custom_file_menu_item, const gchar *stock_id);

#endif
