#ifndef INC_BE_APPLET__DIR_MENU_H
#define INC_BE_APPLET__DIR_MENU_H

#include <gtk/gtk.h>
#include <libgnomevfs/gnome-vfs.h>

#include "icon-loader.h"
#include "readyable.h"

#define BE_DIR_MENU_TYPE            (be_dir_menu_get_type())
#define BE_DIR_MENU(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), BE_DIR_MENU_TYPE, BeDirMenu))
#define BE_DIR_MENU_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), BE_DIR_MENU_TYPE, BeDirMenuClass))
#define BE_IS_DIR_MENU(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BE_DIR_MENU_TYPE))
#define BE_IS_DIR_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BE_DIR_MENU_TYPE))
#define BE_DIR_MENU_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), BE_DIR_MENU_TYPE, BeDirMenuClass))

typedef struct _BeDirMenu BeDirMenu;
typedef struct _BeDirMenuClass BeDirMenuClass;

struct _BeDirMenu {
	GtkMenu parent;

	/* public */
	BeIconLoader *icon_loader;
	GtkIconSize   icon_size;
	guint         ready;

	/* private */
	gchar      *uri;
	GHashTable *children;
	guint       idle;
};

struct _BeDirMenuClass {
	GtkMenuClass parent;

	/* class members */
};

GType be_dir_menu_get_type(void);

GtkWidget *be_dir_menu_new(const gchar *uri, BeIconLoader *icon_loader, GtkIconSize icon_size);

void be_dir_menu_set_uri(BeDirMenu *dir_menu, const gchar *uri);
void be_dir_menu_set_icon_loader(BeDirMenu *dir_menu, BeIconLoader *icon_loader);
void be_dir_menu_set_icon_size(BeDirMenu *dir_menu, GtkIconSize icon_size);

#endif
