#ifndef INC_BE_APPLET__ICON_LOADER_H
#define INC_BE_APPLET__ICON_LOADER_H

#include <glib.h>
#include <gtk/gtk.h>

#define BE_ICON_LOADER_TYPE            (be_icon_loader_get_type())
#define BE_ICON_LOADER(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), BE_ICON_LOADER_TYPE, BeIconLoader))
#define BE_ICON_LOADER_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), BE_ICON_LOADER_TYPE, BeIconLoaderClass))
#define BE_IS_ICON_LOADER(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BE_ICON_LOADER_TYPE))
#define BE_IS_ICON_LOADER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BE_ICON_LOADER_TYPE))
#define BE_ICON_LOADER_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), BE_ICON_LOADER_TYPE, BeIconLoaderClass))

typedef struct _BeIconLoader BeIconLoader;
typedef struct _BeIconLoaderClass BeIconLoaderClass;

struct _BeIconLoader {
	GObject parent;

	/* public */
	GtkIconTheme *icon_theme;

	/* private */
	GHashTable *icons;
	GQueue     *dirty;
	guint       idle;
};

struct _BeIconLoaderClass {
	GObjectClass parent;

	void (*icon_theme_changed)(BeIconLoader *);
};

GType be_icon_loader_get_type(void);

BeIconLoader *be_icon_loader_new(GtkIconTheme *icon_theme);

void be_icon_loader_set_icon_theme(BeIconLoader *, GtkIconTheme *);
GtkIconTheme *be_icon_loader_get_icon_theme(const BeIconLoader *);

void be_icon_loader_icon_theme_changed(BeIconLoader *);

void be_icon_loader_add_image(BeIconLoader *, GtkImage *image, const gchar *name, GtkIconSize icon_size);
GtkWidget *be_icon_loader_image_new(BeIconLoader *icon_loader, const gchar *name, GtkIconSize icon_size);

#endif
