#ifndef INC_BE_APPLET__MAIN_MENU_BUTTON_H
#define INC_BE_APPLET__MAIN_MENU_BUTTON_H

#include <gtk/gtk.h>

#include "icon-loader.h"
#include "menu-button.h"

#define BE_MAIN_MENU_BUTTON_TYPE            (be_main_menu_button_get_type())
#define BE_MAIN_MENU_BUTTON(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), BE_MAIN_MENU_BUTTON_TYPE, BeMainMenuButton))
#define BE_MAIN_MENU_BUTTON_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), BE_MAIN_MENU_BUTTON_TYPE, BeMainMenuButtonClass))
#define BE_IS_MAIN_MENU_BUTTON(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BE_MAIN_MENU_BUTTON_TYPE))
#define BE_IS_MAIN_MENU_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BE_MAIN_MENU_BUTTON_TYPE))
#define BE_MAIN_MENU_BUTTON_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), BE_MAIN_MENU_BUTTON_TYPE, BeMainMenuButtonClass))

typedef struct _BeMainMenuButton BeMainMenuButton;
typedef struct _BeMainMenuButtonClass BeMainMenuButtonClass;

struct _BeMainMenuButton {
	BeMenuButton parent;

	/* public */
	BeIconLoader *icon_loader;

	/* private */
	GtkWidget *main_menu;
};

struct _BeMainMenuButtonClass {
	BeMenuButtonClass parent;

	/* class members */
};

GType be_main_menu_button_get_type(void);

GtkWidget *be_main_menu_button_new(BeIconLoader *icon_loader);

void be_main_menu_button_set_icon_loader(BeMainMenuButton *main_menu_button, BeIconLoader *icon_loader);

#endif
