#ifndef INC_BE_APPLET__MAIN_MENU_H
#define INC_BE_APPLET__MAIN_MENU_H

#include <gtk/gtk.h>

#include "icon-loader.h"

#define BE_MAIN_MENU_TYPE            (be_main_menu_get_type())
#define BE_MAIN_MENU(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), BE_MAIN_MENU_TYPE, BeMainMenu))
#define BE_MAIN_MENU_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), BE_MAIN_MENU_TYPE, BeMainMenuClass))
#define BE_IS_MAIN_MENU(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BE_MAIN_MENU_TYPE))
#define BE_IS_MAIN_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BE_MAIN_MENU_TYPE))
#define BE_MAIN_MENU_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), BE_MAIN_MENU_TYPE, BeMainMenuClass))

typedef struct _BeMainMenu BeMainMenu;
typedef struct _BeMainMenuClass BeMainMenuClass;

struct _BeMainMenu {
	GtkMenu parent;

	/* public */
	BeIconLoader *icon_loader;

	/* private */
	GtkTooltips *tooltips;
	GtkWidget   *applications;
	GtkWidget   *home;
};

struct _BeMainMenuClass {
	GtkMenuClass parent;

	/* class members */
};

GType be_main_menu_get_type(void);

GtkWidget *be_main_menu_new(BeIconLoader *icon_loader);

void be_main_menu_set_icon_loader(BeMainMenu *main_menu, BeIconLoader *icon_loader);

#endif
