#include "config.h"

#include "menu-button.h"

static gboolean be_menu_button_button_press_event(GtkWidget *widget, GdkEventButton *event) {
	switch(event->type) {
		case GDK_BUTTON_PRESS:
			if(!GTK_WIDGET_HAS_FOCUS(widget))
				gtk_widget_grab_focus(widget);

			gtk_item_select(GTK_ITEM(widget));
			break;
		default:
			break;
	}

	return TRUE;
}
static gboolean be_menu_button_button_release_event(GtkWidget *widget, GdkEventButton *event) {
	switch(event->button) {
		case 1:
			gtk_item_deselect(GTK_ITEM(widget));
			break;
		default:
			break;
	}

	return TRUE;
}

#if 0
static gboolean be_menu_button_key_press_event(GtkWidget *widget, GdkEventKey *event, gpointer user_data) {
	BeMenuButton *menu_button = BE_MENU_BUTTON(widget);

	switch (event->keyval) {
		case GDK_KP_Enter:
		case GDK_ISO_Enter:
		case GDK_3270_Enter:
		case GDK_Return:
		case GDK_space:
		case GDK_KP_Space:

			be_menu_button_popup(menu_button);
			return TRUE;
	}

	return FALSE;
}
#endif

static void be_menu_button_instance_init(GTypeInstance *instance, gpointer g_class) {
	BeMenuButton *self = (BeMenuButton *) instance;

	/* Do stuff */
	g_signal_connect(self, "button_press_event", G_CALLBACK(&be_menu_button_button_press_event), NULL);
	g_signal_connect(self, "button_release_event", G_CALLBACK(&be_menu_button_button_release_event), NULL);
#if 0
	g_signal_connect(self, "key_press_event", G_CALLBACK(be_menu_button_key_press_event), NULL);
#endif

	{
		GValue value = {0,};

		g_value_init(&value, G_TYPE_BOOLEAN);
		g_value_set_boolean(&value, TRUE);

		g_object_set_property(G_OBJECT(self), "can-focus", &value);

		g_value_unset(&value);
	}
}

static GObject *be_menu_button_constructor(GType type, guint n_construct_properties, GObjectConstructParam *construct_properties) {
	GObject *obj;

	{ /* Invoke parent constructor. */
		BeMenuButtonClass *klass        = BE_MENU_BUTTON_CLASS(g_type_class_peek(BE_MENU_BUTTON_TYPE));
		GObjectClass      *parent_class = G_OBJECT_CLASS(g_type_class_peek_parent(klass));

		obj = parent_class->constructor(type, n_construct_properties, construct_properties);
	}

	/* Do stuff */

	return obj;
}

#if 0
static void be_menu_button_dispose(GObject *object) {
	BeMenuButtonClass *klass        = BE_MENU_BUTTON_CLASS(g_type_class_peek(BE_MENU_BUTTON_TYPE));
	GObjectClass      *parent_class = G_OBJECT_CLASS(g_type_class_peek_parent(klass));

	/* Do stuff */

	/* Invoke parent dispose */
	parent_class->dispose(object);
}
#endif

static void be_menu_button_finalize(GObject *object) {
	BeMenuButtonClass *klass        = BE_MENU_BUTTON_CLASS(g_type_class_peek(BE_MENU_BUTTON_TYPE));
	GObjectClass      *parent_class = G_OBJECT_CLASS(g_type_class_peek_parent(klass));

	/* Do stuff */

	/* Invoke parent finalize */
	parent_class->finalize(object);
}

static void be_menu_button_class_init(gpointer g_class, gpointer g_class_data) {
	GObjectClass      *gobject_class = G_OBJECT_CLASS(g_class);
	BeMenuButtonClass *klass         = BE_MENU_BUTTON_CLASS(g_class);

	gobject_class->constructor = &be_menu_button_constructor;
/*	gobject_class->dispose     = &be_menu_button_dispose; */
	gobject_class->finalize    = &be_menu_button_finalize;
}

GType be_menu_button_get_type(void) {
	static GType type = 0;

	if(type == 0) {
		static const GTypeInfo info = {
			sizeof(BeMenuButtonClass),     /* class_size */
			NULL,                          /* base_init */
			NULL,                          /* base_finalize */
			&be_menu_button_class_init,    /* class_init */
			NULL,                          /* class_destroy */
			NULL,                          /* class_data */
			sizeof(BeMenuButton),          /* instance_size */
			0,                             /* n_preallocs */
			&be_menu_button_instance_init, /* instance_init */
			NULL                           /* value_table */
		};

		type = g_type_register_static(GTK_TYPE_MENU_ITEM, "BeMenuButtonType", &info, 0);
	}

	return type;
}

#if 0
GtkWidget *be_menu_button_new(void) {
	GtkWidget *menu_button = gtk_widget_new(BE_MENU_BUTTON_TYPE,
		NULL);

	return menu_button;
}
#endif
